from jeb.api import IScript
from jeb.api.ui.View import Type

import re

class DisplayAstClass(IScript):
    def run(self, jeb):
        dex = jeb.getDex()
        ui = jeb.getUI()
        view = ui.getView(Type.JAVA)
        if not ui.isViewVisible(Type.ASSEMBLY):
            print "assembly view is not visible."
            return

        sig = view.getCodePosition().getSignature()

        print sig
        # decompile
        csig = re.sub(r'->.*$', '', sig)
        ui.decompileClass(csig, False)

        cls = jeb.getDecompiledClassTree(csig)
        print "target class: " + cls.getType()
        print "[Method]"
        for m in cls.getMethods():
            print "\t" + m.getSignature()
        print ""
        print "[Field]"
        for f in cls.getFields():
            print "\t" + f.getSignature()
            

