from jeb.api import IScript
from jeb.api.ui.View import Type

class TraverseAst(IScript):
    def run(self, jeb):
        dex = jeb.getDex()
        ui = jeb.getUI()
        view = ui.getView(Type.JAVA)
        if not ui.isViewVisible(Type.JAVA):
            print "java view is not visible."
            return

        sig = view.getCodePosition().getSignature()
        if sig in dex.getMethodSignatures(False):
            method = jeb.getDecompiledMethodTree(sig)
            self.traverse(method.getBody())
        else:
            print "caret is not in method.: " + sig

    def traverse(self, elem, depth=0):
        print("%s[%d]%s" % (' '*depth, depth, elem.__class__.__name__))
        for e in elem.getSubElements():
            self.traverse(e, depth+1)

